/**
 * 数组转二叉树
 * @param  arr
 */
export function arrToBinaryTree(arr) {
    if (!Array.isArray(arr) || arr.length === 0) {
        return null;
    }
    var root = null;
    var offset = 0;
    // 根节点从1开始
    var size = 1;
    var parentNodes = [];
    // 每次提取一层数据进行构建
    var levelChunk = arr.slice(offset, offset + size);
    // 用来存储每层构建的结果
    var buildChunk = [];
    offset += size;
    while (levelChunk.length) {
        var counter = 0;
        for (var i = 0; i < levelChunk.length; i++) {
            var val = levelChunk[i];
            var treeNode = null;
            if (val !== null) {
                // 计算出每层节点数
                counter++;
                treeNode = {
                    val: val,
                    left: null,
                    right: null,
                };
            }
            // 根据当前层节点的数据计算出父节点所在的位置
            var parentIdx = Math.floor(i / 2);
            var isLeftChild = i % 2 === 0;
            if (!parentNodes[parentIdx] && root === null) {
                root = treeNode;
            }
            else if (parentNodes[parentIdx]) {
                // 挂载左右儿子节点
                if (isLeftChild) {
                    parentNodes[parentIdx].left = treeNode;
                }
                else {
                    parentNodes[parentIdx].right = treeNode;
                }
            }
            buildChunk[i] = treeNode;
        }
        // 把当前层的空节点过滤掉，重新构建关系
        parentNodes = buildChunk.filter(function (x) { return x !== null; });
        // 计算出下一层的节点数
        size = 2 * counter;
        levelChunk = arr.slice(offset, offset + size);
        offset += size;
    }
    return root;
}
