/**
 * 简单版本的并查集实现，即数组的索引即代表的是它所存储的数据
 */
export declare class SimpleDsu {
    protected _set: number[];
    get dataSet(): number[];
    constructor(n: number);
    /**
     * 初始化并查集
     * @param n
     */
    init(n: number): void;
    /**
     * 查找num在集合中是否存在，若存在返回其所在集合的跟节点的索引（即编号），若不存在，则返回-1
     * @param num
     * @returns
     */
    find(num: number): number;
    /**
     * 合并两个集合，按秩归并
     * @param num1
     * @param num2
     */
    union(num1: number, num2: number): void;
    /**
     * 统计集合的个数
     * @returns
     */
    count(): number;
}
